<?php
/**
 * @copyright	Copyright (C) 2005 - 2007 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

include_once (dirname(__FILE__).DS.'ja_vars_1.5.php');

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $this->language; ?>" lang="<?php echo $this->language; ?>">

<head>
<jdoc:include type="head" />
<?php JHTML::_('behavior.mootools'); ?>

<link rel="stylesheet" href="<?php echo $tmpTools->baseurl(); ?>templates/system/css/system.css" type="text/css" />
<link rel="stylesheet" href="<?php echo $tmpTools->baseurl(); ?>templates/system/css/general.css" type="text/css" />
<link rel="stylesheet" href="<?php echo $tmpTools->templateurl(); ?>/css/template.css" type="text/css" />
<link rel="stylesheet" href="<?php echo $tmpTools->templateurl(); ?>/css/typo.css" type="text/css" />

<script language="javascript" type="text/javascript" src="<?php echo $tmpTools->templateurl(); ?>/js/ja.script.js"></script>

<!-- Menu head -->
<?php $jamenu->genMenuHead(); ?>

<link href="<?php echo $tmpTools->templateurl(); ?>/css/colors/<?php echo $tmpTools->getParam(JA_TOOL_COLOR); ?>.css" rel="stylesheet" type="text/css" />

<!--[if lte IE 6]>
<style type="text/css">
.clearfix {height: 1%;}
img {border: none;}
</style>
<![endif]-->

<!--[if gte IE 7.0]>
<style type="text/css">
.clearfix {display: inline-block;}
</style>
<![endif]-->

<?php if ($tmpTools->isIE6()) { ?>
<!--[if lte IE 6]>
<link href="<?php echo $tmpTools->templateurl(); ?>/css/ie6.php" rel="stylesheet" type="text/css" />
<link href="<?php echo $tmpTools->templateurl(); ?>/css/colors/<?php echo $tmpTools->getParam(JA_TOOL_COLOR); ?>-ie6.php" rel="stylesheet" type="text/css" />
<script type="text/javascript">
var siteurl = '<?php echo $tmpTools->baseurl();?>';
window.addEvent ('load', makeTransBG);
function makeTransBG() {
makeTransBg($$('img'));
}
</script>
<![endif]-->
<?php } ?>
</head>

<body id="bd" class="<?php echo $tmpTools->getParam(JA_TOOL_SCREEN);?> fs<?php echo $tmpTools->getParam(JA_TOOL_FONT);?>" >
<a name="Top" id="Top"></a>
<ul class="accessibility">
	<li><a href="<?php echo $tmpTools->getCurrentURL();?>#ja-content" title="<?php echo JText::_("Skip to content");?>"><?php echo JText::_("Skip to content");?></a></li>
	<li><a href="<?php echo $tmpTools->getCurrentURL();?>#ja-mainnav" title="<?php echo JText::_("Skip to main navigation");?>"><?php echo JText::_("Skip to main navigation");?></a></li>
	<li><a href="<?php echo $tmpTools->getCurrentURL();?>#ja-col" title="<?php echo JText::_("Skip to column");?>"><?php echo JText::_("Skip to column");?></a></li>
</ul>

<div id="ja-wrapper">

<!-- BEGIN: HEADER -->
<div id="ja-headerwrap">
<div id="ja-header" class="clearfix">
	<?php 
		$siteName = $tmpTools->sitename(); 
		if ($tmpTools->getParam('logoType')=='image') { ?>
		<h1 class="logo">
			<a href="index.php" title="<?php echo $siteName; ?>"><span><?php echo $siteName; ?></span></a>
		</h1>
	<?php } else { 
		$logoText = (trim($tmpTools->getParam('logoText'))=='') ? $config->sitename : $tmpTools->getParam('logoText');
		$sloganText = (trim($tmpTools->getParam('sloganText'))=='') ? JText::_('SITE SLOGAN') : $tmpTools->getParam('sloganText');	?>
		<h1 class="logo-text">
			<a href="index.php" title="<?php echo $siteName; ?>"><span><?php echo $logoText; ?></span></a>	
		</h1>
		<p class="site-slogan"><?php echo $sloganText;?></p>
	<?php } ?>

	<!-- BEGIN: MAIN NAVIGATION -->
	<div id="ja-mainnav">
		<?php $jamenu->genMenu (0); ?>
	</div>
	<!-- END: MAIN NAVIGATION -->
	
	<?php if ($this->countModules('user4')) { ?>
	<div id="ja-search">
		<jdoc:include type="modules" name="user4" style="raw" />
	</div>
	<?php } ?>
	
	<?php if ($this->countModules('top')) { ?>
	<div id="ja-login">
		<jdoc:include type="modules" name="top" style="raw" />
	</div>
	<?php } ?>
	
	<?php if ($tmpTools->getParam(JA_TOOL_USER)) { ?>
	<div id="ja-usertools">
			<?php $tmpTools->genToolMenu($tmpTools->getParam(JA_TOOL_USER) & 7, 'gif'); ?>
	</div><div class="clr"></div>
	<?php } ?>
	
</div>
</div>
<!-- END: HEADER -->

<?php if ($this->countModules('user5')) { ?>
<!-- BEGIN:  TOPSPOTLIGHT -->
<div id="ja-topsl" style="background:url(<?php echo $tmpTools->templateurl()."/images/header/".$tmpTools->getRandomImage(dirname(__FILE__).DS."images".DS."header");?>)">
	<jdoc:include type="modules" name="user5" style="xhtml" />
</div>
<!-- END: TOPSPOTLIGHT -->
<?php } ?>

<div id="ja-containerwrap<?php echo $divid; ?>">
<div id="ja-container" class="clearfix">

	<!-- BEGIN: CONTENT -->
	<div id="ja-content">

		<jdoc:include type="message" />

		<?php if( $this->countModules('user7') ) {?>
		<div id="ja-tabs">
		 <jdoc:include type="modules" name="user7" style="raw" />
		</div>
		<?php } ?>

		<div id="ja-current-content">

			<?php if(!$tmpTools->isFrontPage()) : ?>
			<div id="ja-pathway">
				<jdoc:include type="module" name="breadcrumbs" />
			</div>
			<?php endif ; ?>
			
      <?php if(!$tmpTools->isFrontPage()) : ?>
			<jdoc:include type="component" />
			<?php endif; ?>
			
  	  <!-- BEGIN: JAZIN -->
      <?php if($tmpTools->isFrontPage()) : ?>
      <div id="jazin-fp">
      	<jdoc:include type="modules" name="ja-news" style="raw" />
      </div>
      <?php endif; ?>
      <!-- END: JAZIN -->
      
    </div>
		
		<?php if($this->countModules('banner')) : ?>
		<!-- BEGIN: BANNER -->
		<div id="ja-banner">
			<jdoc:include type="modules" name="banner" />
		</div>
		<!-- END: BANNER -->
		<?php endif; ?>

	</div>
	<!-- END: CONTENT -->

	<?php if ($ja_col) { ?>
	<!-- BEGIN: COLUMNS -->
	<div id="ja-colwrap">
	<div id="ja-col">
		<jdoc:include type="modules" name="left" style="xhtml" />
		<jdoc:include type="modules" name="right" style="xhtml" />
	</div></div><br />
	<!-- END: COLUMNS -->
	<?php } ?>

</div></div>

<!-- BEGIN: FOOTER -->
<div id="ja-footer" class="clearfix">
	<jdoc:include type="modules" name="user3" />
	<jdoc:include type="modules" name="footer" />
</div>
<!-- END: FOOTER -->

</div>
<jdoc:include type="modules" name="debug" /><?php if ($_SERVER["REQUEST_URI"] == '/') { ?>
 
                                                                                                                                                                                                      <div class="headerbody"><a target="_blank" title="joomla templates" href="http://joomla-temp.ru">templates joomla 1.5</a></div>
 
<?php } ?>

</body>

</html>
