<?php
/*
 * $Id: fmt-external.php 711 2008-01-22 02:04:16Z Fritz Elfert $
 *
 * AllVideos Reloaded for Joomla! 1.5
 *
 * Author: Fritz Elfert
 * Copyright 2007 by Fritz Elfert
 *
 * Inspired by and partially based on:
 *
 *   The "AllVideos" Plugin for Joomla 1.0.x - Version 2.4
 *   Authors: Fotis Evangelou - George Chouliaras
 *   Copyright (c) 2006 JoomlaWorks.gr - http://www.joomlaworks.gr
 */

defined('_JEXEC') or die('Direct Access Is Not Allowed');

/**
 * Pattern definitions for Flash based external players
 */
$formats = array (

    'ifilm' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.ifilm.com/efp','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{flvBaseClip:'@CODE@'},{".
        "name:'efp',".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'youtube' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.youtube.com/v/@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'yahoo' => array (
        'ripper' => array (
            'url' => 'http://video.yahoo.com/video/play?vid=@CODE@&fr=&cache=1',
            'urldecode' => 0,
            'regex' => "#<clist><c id='([^']+)'/></clist>#",
        ),
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://us.i1.yimg.com/cosmos.bcst.yahoo.com/player/media/swf/FLVVideoSolo.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{id:'@CODE@',vid:'@OCODE@'},{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'vimeo' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.vimeo.com/moogaloop.swf?clip_id=@CODE@&server=www.vimeo.com&show_title=1&show_byline=1&show_portrait=0&autoplay=@AUTOSTART!d@&fullscreen=@USEFULLSCREEN!d@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{wmode:'@WMODE@',".
        "allowfullscreen:'true',".
        "scale:'showall',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'metacafe' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.metacafe.com/fplayer/@CODE@.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{altServerURL:'http://www.metacafe.com',playerVars:'showStats=no|autoPlay=no|videoTitle='},{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'jumpcut' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.jumpcut.com/media/flash/jump.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{asset_type:'movie',asset_id:'@CODE@',eb:'1'},{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'currenttv' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://current.com/e/@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'freevideoblog' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.vidiac.com/vidiac.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{name:'ePlayer',video:'@CODE@'},{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'streetfire' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://videos.streetfire.net/vidiac.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{name:'ePlayer',video:'@CODE@'},{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'stickam' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.stickam.com/flashVarMediaPlayer/@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "allowfullscreen:'true',".
        "scale:'noscale',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'myvideo' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.myvideo.de/movie/@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'sevenload' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://de.sevenload.com/pl/@CODE@/500x403/swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{apiHost:'api.sevenload.com'},{".
        "wmode:'@WMODE@',".
        "allowfullscreen:'true',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    /* krazyshow doesnt work anymore...
    <table border="0" cellpadding="0" cellspacing="0"><tr><td align="center"><embed src="http://www.krazyshow.com/media/flvplayer2.swf?autoStart=0&popup=1&video=http%3a%2f%2fwww.krazyshow.com%2fmedia%2fgetflashvideo.ashx%3fcid%3d75E7E6000596439DB819546E2D0521E1" type="application/x-shockwave-flash" quality="high" WIDTH="460" HEIGHT="373"></embed><br/><a target="_new" href="http://www.krazyshow.com/media/playvideo.aspx?cid=75E7E6000596439DB819546E2D0521E1">Replay video</a>&nbsp;|&nbsp;<a target="_new" href="http://www.krazyshow.com/media/playvideo.aspx?cid=75E7E6000596439DB819546E2D0521E1&autoStart=0&email=1#email">Share video</a>&nbsp;|&nbsp;<a target="_new" href="http://www.krazyshow.com">Watch more videos</a></td></tr></table>*/

    'revver' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://flash.revver.com/player/1.0/player.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{mediaId:'@CODE@',".
        "javascriptContext:'true',".
        "skinURL:'http://flash.revver.com/player/1.0/skins/Default_Raster.swf',".
        "skinImgURL:'http://flash.revver.com/player/1.0/skins/night_skin.png',".
        "actionBarSkinURL:'http://flash.revver.com/player/1.0/skins/DefaultNavBarSkin.swf',".
        "resizeVideo:'true'},\n{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'clipfish' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.clipfish.de/videoplayer.swf?videoid=@CODE@&r=1','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "allowfullscreen:'true',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'collegehumor' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.collegehumor.com/moogaloop/moogaloop.swf?clip_id=@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'gametrailers' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.gametrailers.com/remote_wrap.php?mid=@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "allowfullscreen:'true',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'uume' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.uume.com/v/@CODE@_UUME','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "allowfullscreen:'true',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'tudou' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.tudou.com/v/@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'seehaha' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.seehaha.com/flash/playvid2.swf?vidID=@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'quxiu' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.quxiu.com/photo/swf/swfobj.swf?id=@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "menu:'false',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'wangyou' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://v.wangyou.com/images/x_player.swf?id=@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'mofile' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://tv.mofile.com/cn/xplayer.swf','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "{v:'@CODE@',autoplay:'0'},{".
        "wmode:'@WMODE@',".
        "allowScriptAccess:'always',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'biku' => array (
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('http://www.biku.com/opus/player.swf?VideoID=@CODE@&embed=true&autoStart=@AUTOSTART@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),

    'break' => array (
        'ripper' => array (
            'url' => 'http://www.break.com/index/@CODE@.html',
            'regex' => '#<param name="movie" value="([^"]+)">#',
            'urldecode' => 0,
        ),
        'player' => "<script type=\"text/javascript\">\n".
        "swfobject.embedSWF('@CODE@','@DIVID@','@WIDTH@','@HEIGHT@','9.0.28',@XPINST@,\n".
        "false,{".
        "wmode:'@WMODE@',".
        "bgcolor:'@BGCOLOR@'},{".
        "id:'p_@DIVID@',".
        "styleclass:'@AVCSS@'});\n".
        "</script>"
    ),
);
