<?php
/*------------------------------------------------------------------------
# JA tabs 1.0 - June, 2008
# ------------------------------------------------------------------------
# Copyright (C) 2004-2008 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
# @license - Copyrighted Commercial Software
# Author: J.O.O.M Solutions Co., Ltd
# Websites:  http://www.joomlart.com -  http://www.joomlancers.com
-------------------------------------------------------------------------*/

// Check to ensure this file is included in Joomla!

defined( '_JEXEC' ) or die();
jimport( 'joomla.plugin.plugin' );
jimport('joomla.application.module.helper');

/**
 * Jatabs Content Plugin
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 		1.5
 */
class plgContentJA_tabs extends JPlugin
{

	function plgContentJA_tabs( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	/**
	 * tabs prepare content method
	 *
	 * Method is called by the view
	 *
	 * @param 	object		The article object.  Note $article->text is also available
	 * @param 	object		The article params
	 * @param 	int			The 'page' number
	 */
	function onPrepareContent( &$article, &$params, $limitstart )
	{
		global $mainframe;
		
		$plugin	=& JPluginHelper::getPlugin('content', 'ja_tabs');
		$pluginParams	= new JParameter( $plugin->params );

		if (JString::strpos( $article->text, '{jatabs' ) === false){
			$HSmethodDIRECT = false;
		}else{
			$HSmethodDIRECT = true;
		}

		if(!defined("JAMOOTAB_PLUGIN_HEADTAG")) $this->Jatabs_PrepareSettings($pluginParams);
		if($HSmethodDIRECT)
		{
			$regex = $this->getPattern('jatabs');
			$article->text = preg_replace_callback($regex, array(&$this, 'Jatabs_replacer_DIRECT'),$article->text);
		}
		return $article->text;
	}

	function Jatabs_PrepareSettings($pluginParams){
		global $mainframe;
		
		$hs_base    = JURI::base().'plugins/content/ja_tabs/';
		$headtag    = array();
		$headtag[] = '<link rel="stylesheet" href="'.$hs_base.'ja_tabs.css" type="text/css" media="screen"/>';
		$headtag[] = "<script type='text/javascript' src='".$hs_base."ja_tabs.js' charset=\"utf-8\"></script>";
		$headtag[] = JHTML::_('behavior.mootools');	
	
		$mainframe->addCustomHeadTag(implode("\n", $headtag));
		define("JAMOOTAB_PLUGIN_HEADTAG", TRUE);

	}
	function Jatabs_replacer_DIRECT(&$matches)
	{		
		//params of tab
		$params = '';
		$params = $this->parseParams($matches[1]);
		
		switch ($params['type']){
			case 'content':
				return $this->parseTabContent($matches[2], $params);				
			case 'modules':
				return $this->parseTabModules($params);
			case 'module':
				return $this->parseTabModule($params);
			case 'articles':	
				return $this->parseTabArticle($params);				
		}
		
		
	}	
	
	function parseTabContent($matches, $params){		
		$tabs ='';
		$_SESSION['li'] = null;
		$_SESSION['div'] = null;
		$regex = $this->getSubPattern('tab');
		$tabs .= preg_replace_callback($regex, array(&$this, 'wirentTabContent'), $matches);
		if($_SESSION['li']!=null){
			return $this->writeTabs($_SESSION['li'], $_SESSION['div'], $params);
		}
		return '';
	}
	
	function wirentTabContent(&$matches){
		$params = $this->parseParams($matches[1]);
		$_SESSION['li'] .= "<li><h3><span>".$params['title']."</span></h3></li>";
		
		$_SESSION['div'] .= "<div class=\"ja-tab-content\">
								<div class=\"ja-tab-subcontent\">"
									.$matches[2]
							.'  </div>
							</div>';		
	}
	
	function parseTabModules($params){
		$module_content = ''; $lis = ''; $divs = '';
		$list =  JModuleHelper::getModules(trim($params['module']));
		for($j=0; $j<count($list); $j++){
			$lis  .= "<li><h3><span>".$list[$j]->title."</span></h3></li>";
			$divs .= "<div  class=\"ja-tab-content\">
						<div class=\"ja-tab-subcontent\">"
						.JModuleHelper::renderModule($list[$j], array())
					 .' </div>
					 </div>';			
		}
		if($lis!=''){
			return $this->writeTabs($lis, $divs, $params);
		}
		return '';	
	}
	
	function parseTabModule($params){
		$lis = ''; $divs = ''; $list_module=array();
		if(isset($params['modulename']) && $params['modulename']) $list_module = split(",", $params['modulename']);	
		for($i=0; $i<count($list_module); $i++){
			$module =  JModuleHelper::getModule(substr(trim($list_module[$i]), 4 ));

			if($module && $module->id){
				$lis  .= "<li><h3><span>".$module->title."</span></h3></li>";
				$divs .= "<div  class=\"ja-tab-content\">
						<div class=\"ja-tab-subcontent\">"
						.JModuleHelper::renderModule($module, array())
					 .' </div>
					 </div>';	
			}				
		}		
		if($lis!=''){
			return $this->writeTabs($lis, $divs, $params);
		}
		return '';		
	}		
	
	function parseTabArticle($params){
		$list = null; $lis = ''; $divs = '';
		if(isset($params['ids'])){
			$list = $this->getList($params['ids'], '');
		}
		elseif (isset($params['catid'])){
			if(!isset($params['numberTabs']) || $params['numberTabs']<=0) 	$params['numberTabs']  	= 3;
			$list = $this->getList('', $params['catid'], $params['numberTabs']);
		}
		$maxchars;
		if($list){
			foreach ($list as $row){
				$lis  .= "<li><h3><span>".$row->title."</span></h3></li>";
				$divs .= "<div  class=\"ja-tab-content\">
							<div class=\"ja-tab-subcontent\">"
							.$row->introtext
						 .' </div>
						 </div>';			
			}
			return $this->writeTabs($lis, $divs, $params);
		}
		return '';
	}	
	
	function writeTabs($lis, $divs, $params){
		global $mainframe;
		$padding = '';
		
		if(!isset($params['width']) || $params['width']<=0) 	$params['width']  	= 300;
		if(!isset($params['height']) || $params['height']) 		$params['height'] 	= 200;	
		if(!isset($params['heightTabs']) || $params['heightTabs']<0) 	$params['heightTabs'] 	= 30;		
		if(!isset($params['animType'])) 						$params['animType'] = 'animMoveHor';
		if(isset($params['skipAnim']) && $params['skipAnim']=='') 	{$params['skipAnim'] 	= 'false';	}

		if(!isset($params['position'])){
			$params['position'] = 'top';
		}
		$params['position'] = strtolower($params['position']);
		if(!isset($params['widthTabs']) && ($params['position']=='left' || $params['position']=='right')){
			$params['widthTabs'] 		= 110;			
		}
		if ($params['position']=='top' || $params['position']=='bottom'){
			$params['widthTabs']  = $params['width'];
			$width = $params['width'];
		}		
		if ($params['position']=='left') {
			$padding = 'left:'.($params['widthTabs'] + 5).'px;';
			$width = $params['width']-$params['widthTabs'];
		}
		if ($params['position']=='right') {
			$width = $params['width']-$params['widthTabs'];
		}
		if (!isset($params['style'])) {
			$params['style'] = 'basic';
		}	
		if (!isset($params['mouseType'])) {
			$params['mouseType'] = 'click';
		}
		
		$override = '';
		foreach($params as $k=>$value){
			if($k!='type' && $k!='module'){
				if(is_numeric($value) || $k=='skipAnim'){
					$override .= $k.":".$value.",";
				}				
				else	$override .= $k.":'".$value."',";
			}
		}				
		if($override!=''){
			$override = substr($override, 0, strlen($override)-1);
		}
		if(!defined("JAMOOTAB_HEADTAG_".strtoupper($params['style']))){
			$headtag[] = '<link rel="stylesheet" href="'.JURI::base().'plugins/content/ja_tabs/themes/'.$params['style'].'/style.css" type="text/css" media="screen"/>';
			$mainframe->addCustomHeadTag(implode("\n", $headtag));
			define("JAMOOTAB_HEADTAG_".strtoupper($params['style']), true);
		}
		
		$id = 'myTab-'.rand(); $idtab = rand();
		$html = '<script type="text/javascript" charset="utf-8">
						window.addEvent("load", init);
						function init() {
							myTabs1 = new JATabs("'.$id.'", {'.$override.'});							
						}
				</script>';	
			if ($params['height']>0) {
				$params['height'] .= 'px';
			}
			$html .= '<div class="ja-tabswrap" style="width:'.$params['width'].'px;  height:'.$params['height'].'">';
			$html.=	 '	<div id="'.$id.'" class="container" >';	
			if($params['position']=='top'){
				$html .= '	<div class="ja-tabs-title-'.$params['position'].'" style="width:'.$params['widthTabs'].'px; height:'.$params['heightTabs'].'px">';
			}
			elseif($params['position']!='bottom'){
				$html.=	 '	<div class="ja-tabs-title-'.$params['position'].'" style="width:'.$params['widthTabs'].'px;">';
			}
			if($params['position']!='bottom'){					
				$html.=	 '			
								<ul class="ja-tabs-title">'
									.$lis
							.	'</ul>
							</div>						
							<div class="ja-tab-panels-'.$params['position'].'" style="width:'.($width-20).'px;'.$padding.';">'
							.	$divs
							.'</div>';
			}
			else{
				$html.=	 '			
							<div class="ja-tab-panels-'.$params['position'].'" style="width:'.($width-20).'px;'.$padding.'; ">'
								.	$divs
							.'</div>
							<div class="ja-tabs-title-'.$params['position'].'" style="width:'.$params['widthTabs'].'px;top:'.($params['height']-$params['heightTabs']).'px">
									<ul class="ja-tabs-title">'
										.$lis
								.	'</ul>
							</div>';
			}						
			$html.=	 '	</div>
					</div>';
		
		return $html;
	}
	
	function getList($ids='', $catid='', $limit=5)
	{
		global $mainframe;
		$db 	=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$aid	= $user->get('aid', 0);

		$contentConfig	= &JComponentHelper::getParams( 'com_content' );
		$noauth			= !$contentConfig->get('shownoauth');

		jimport('joomla.utilities.date');
		$date = new JDate();
		$now = $date->toMySQL();

		$nullDate = $db->getNullDate();

		// query to determine article count
		$query = 'SELECT a.*,cc.description as catdesc, cc.title as cattitle,s.description as secdesc, s.title as sectitle,' .
			' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
			' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug,'.
			' CASE WHEN CHAR_LENGTH(s.alias) THEN CONCAT_WS(":", s.id, s.alias) ELSE s.id END as secslug'.
			' FROM #__content AS a' .
			' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
			' INNER JOIN #__sections AS s ON s.id = a.sectionid';
		$query .=	' WHERE a.state = 1 ' .
			($noauth ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid. ' AND s.access <= ' .(int) $aid : '').
			' AND (a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' ) ' .
			' AND (a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )' .				
			' AND cc.section = s.id' .
			' AND cc.published = 1' .
			' AND s.published = 1';
		if($ids!=''){
			$query .= "\n AND a.id in ($ids)";
		}
		if($catid != '') {
			$query .=	" AND a.catid=$catid";
		}						
		$query .= ' ORDER BY a.created DESC ' ;		
		if($catid != '') {
			$query .=	"LIMIT 0, $limit";
		}

		$db->setQuery($query);
		$rows = $db->loadObjectList();
	
		return $rows;
	}
	
	function getPattern ($tag) {
	  $regex = '#{'.$tag.' ([^}]*)}([^{]*){/'.$tag.'}#m';
	  return $regex;
	}

	function getSubPattern ($tag) {
	  $regex = '#\['.$tag.' ([^\]]*)\]([^\[]*)\[/'.$tag.'\]#m';
	  return $regex;
	}
	
	function parseParams($params) {
		  $regex = "/\s*([^=\s]+)\s*=\s*('([^']*)'|\"([^\"]*)\"|([^\s]*))/";
		  preg_match_all($regex, $params, $matches);
		
		  $paramarray = null;
		  if(count($matches)){
				$paramarray = array();
				for ($i=0;$i<count($matches[1]);$i++){ 
				  $key = $matches[1][$i];
				  $val = $matches[3][$i]?$matches[3][$i]:($matches[4][$i]?$matches[4][$i]:$matches[5][$i]);
				  $paramarray[$key] = $val;
				}
		  }
		  
		  return $paramarray;
	}
}
?>