var JATabs = new Class({	
	initialize: function(element, options) {
		this.options = Object.extend({
			position:			'top',
			width:				'100%',
			height:				'auto',
			skipAnim:			false,
			animType:			'animMoveHor',
			mouseType:			'mouseover',
			changeTransition:	Fx.Transitions.Pow.easeIn,
			duration:			1000,
			mouseOverClass:		'hover',
			activateOnLoad:		'first'
		}, options || {});

		this.el = $(element);
		this.elid = element;		
				
		this._w = this.el.offsetWidth.toInt();
		this._H = this.el.offsetHeight.toInt();
		
		this.titles = $$('#' + this.elid + ' div.ja-tabs-title-'+this.options.position+' ul li');

		this.panels = $$('#' + this.elid + ' .ja-tab-content');
		this.titles.each(function(el,i){
			el.panel = this.panels[i];
		},this);
		//add 
		if (this.panels.length <= 1)
		{
			this.panels.setStyle('padding', '0 20px');
			return;
		}
		
		this.titles.each(function(item) {
			item.addEvent(this.options.mouseType, function(){
					//add 2			
					if (item.className.indexOf('active') != -1) return;
					item.removeClass(this.options.mouseOverClass);
					this.activate(item, this.options.skipAnim);						
				}.bind(this)
			);
			
			item.addEvent('mouseover', function() {
				if(item != this.activeTitle)
				{
					item.addClass(this.options.mouseOverClass);
				}
			}.bind(this));
			
			item.addEvent('mouseout', function() {
				if(item != this.activeTitle)
				{
					item.removeClass(this.options.mouseOverClass);
				}
			}.bind(this));
		}.bind(this));
		
		//add
		this.titles[0].className = 'first';
		this.titles[this.titles.length-1].className = 'last';
		
		this.panelwrap = $E('.ja-tab-panels-'+this.options.position, this.el);	
		
		if (this.options.skipAnim) this.options.animType = 'animNone';
		this.anim = eval ('new '+this.options.animType + '(this)');
		if (!this.anim) this.anim = new animNone(this);
		
		if(this.options.activateOnLoad != 'none')
		{
			if(this.options.activateOnLoad == 'first')
			{
				this.activate(this.titles[0], true);
			}
			else
			{
				this.activate(this.options.activateOnLoad, true);	
			}
		}
	},
	
	activate: function(tab, skipAnim){
		if(! $defined(skipAnim))
		{
			skipAnim = false;
		}
		if($type(tab) == 'string') 
		{
			myTab = $$('#' + this.elid + ' ul li').filterByAttribute('title', '=', tab)[0];
			tab = myTab;
		}
		
		if($type(tab) == 'element')
		{
			//add 5
			var newTab = tab.panel;
			var curTab = this.activePanel;
			this.activePanel = newTab;
			
			this.anim.move (curTab, newTab, skipAnim);
			
			this.titles.removeClass('active');
			
			if (this.activeTitle)
				this.activeTitle.className = this.activeTitle.className.replace(new RegExp("active"), "");
			tab.className = tab.className.replace(new RegExp(this.options.mouseOverClass), "");
			
			tab.className += 'active';
			
			this.activeTitle = tab;
			
			if(this.options.useAjax)
			{
				this._getContent();
			}

		}
	},

	next: function(){
		var nextTab = this.activeTitle.getNext();
		if(!nextTab) {
			nextTab = this.titles[0];
		}
		this.activate(nextTab);
	},
	
	previous: function(){
		var previousTab = this.activeTitle.getPrevious();
		if(!previousTab) {
			previousTab = this.titles[this.titles.length - 1];
		}
		this.activate(previousTab);
	}
});
var animNone = new Class ({
	initialize: function(tabwrap) {
		this.options = tabwrap.options || {};
		this.tabwrap = tabwrap;

		this.tabwrap.panels.setStyle('position', 'absolute');
		this.tabwrap.panels.setStyle('left', 0);
	},

	move: function (curTab, newTab, skipAnim) {
		this.tabwrap.panels.setStyle('display', 'none');
		newTab.setStyle('display', 'block');
	}
});

var animFade = new Class ({
	initialize: function(tabwrap) {
		this.options = tabwrap.options || {};
		this.tabwrap = tabwrap;

		this.tabwrap.panels.setStyles({'opacity':0,'width':'100%'});
	},
//'position':'absolute','display':'block','left':0,
	move: function (curTab, newTab, skipAnim) {
		if(this.options.changeTransition != 'none' && skipAnim==false)
		{
			if (curTab)
			{
				curOpac = curTab.getStyle('opacity');
				var changeEffect = new Fx.Style(curTab, 'opacity', {duration: this.options.duration, transition: this.options.changeTransition});
				changeEffect.stop();
				changeEffect.start(curOpac,0);
			}
			curOpac = newTab.getStyle('opacity');
			var changeEffect = new Fx.Style(newTab, 'opacity', {duration: this.options.duration, transition: this.options.changeTransition});
			changeEffect.stop();
			changeEffect.start(curOpac,1);
		} else {
			if (curTab) curTab.setStyle('opacity', 0);
			newTab.setStyle('opacity', 1);
		}
	}
});

var animMoveHor = new Class ({
	initialize: function(tabwrap) {
		this.options = tabwrap.options || {};
		this.tabwrap = tabwrap;
		this.changeEffect = new Fx.Elements(this.tabwrap.panels, {duration: this.options.duration});
			
		var w = this.tabwrap._w - 20;				
		var pos = 0;
		this.tabwrap.panels.each(function(panel){
			panel.setStyle('left', pos);
			pos += w;
		});
	},

	move: function (curTab, newTab, skipAnim) {
		if(this.options.changeTransition != 'none' && skipAnim==false)
		{
			this.changeEffect.stop();
			var obj = {};
			var offset = newTab.offsetLeft.toInt();
			var i=0;
			this.tabwrap.panels.each(function(panel) {
				obj[i++] = {'left':[panel.offsetLeft.toInt(), panel.offsetLeft.toInt() - offset]};
			});
			this.changeEffect.start(obj);
		}
	}
});

var animMoveVir = new Class ({
	initialize: function(tabwrap) {
		this.options = tabwrap.options || {};
		this.tabwrap = tabwrap;
		this.changeEffect = new Fx.Elements(this.tabwrap.panels, {duration: this.options.duration});

		var top = this.tabwrap._H;		
		var pos = 0;
		this.tabwrap.panels.each(function(panel){
			panel.setStyle('top', pos);
			pos += top;
		});
	},

	move: function (curTab, newTab, skipAnim) {
		if(this.options.changeTransition != 'none' && skipAnim==false)
		{
			this.changeEffect.stop();
			var obj = {};
			var offset = newTab.offsetTop.toInt();
			var i=0;
			this.tabwrap.panels.each(function(panel) {
				obj[i++] = {'top':[panel.offsetTop.toInt(), panel.offsetTop.toInt() - offset]};
			});
			this.changeEffect.start(obj);
		}
	}
});