<?php
/**
* @version		$Id: helper.php 7274 2007-05-02 17:40:09Z jinx $
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2007 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');
if(!defined('_JA_NEWS_')) {
	define ('_JA_NEWS_', 1);
	
	require_once (JPATH_SITE . '/components/com_content/helpers/route.php');

	class JaNewsHelper
	{

		function replaceImage( &$row, $align, $autoresize, $maxchars, $showimage, $width = 0, $height = 0, $hiddenClasses = '' ) {
			global $database, $_MAMBOTS, $current_charset;
			$regex = "/\<img.+src\s*=\s*\"([^\"]*)\"[^\>]*\>/";
			$row->introtext = $row->text;
			preg_match ($regex, $row->introtext, $matches);
			if(!count($matches)) preg_match ($regex, $row->fulltext, $matches);
			$images = (count($matches)) ? $matches : array();
			$image = '';
			if (count($images)) $image = $images[1];
		  $align = $align?"align=\"$align\"":"";
			if ($image && $showimage) {
				if ($autoresize && function_exists('imagecreatetruecolor') 
					&& ($image1 = JaNewsHelper::processImage ( $image, $width, $height ))) {
						$image = "<img src=\"".$image1."\" alt=\"{$row->title}\" $align />";
				} else {
					$width = $width?"width=\"$width\"":"";
					$height = $height?"height=\"$height\"":"";
					$image = "<img src=\"".$image."\" alt=\"{$row->title}\" $width $height $align />";
				}
			} else $image = '';

			$regex1 = "/\<img.*\/\>/";
			$row->introtext = preg_replace( $regex1, '', $row->introtext );
			$regex1 = "/<div class=\"mosimage\".*<\/div>/";
			$row->introtext = preg_replace( $regex1, '', $row->introtext );
			$row->introtext = trim($row->introtext);
			//$row->introtext1 = strip_tags($row->introtext);
			if ($maxchars && strlen ($row->introtext) > $maxchars) {
				//$row->introtext1 = substr ($row->introtext1, 0, $maxchars) . "...";
				$row->introtext1 = SmartTrim::trim($row->introtext, 0, $maxchars, $hiddenClasses);
			}else {
			  $row->introtext1 = strip_tags($row->introtext);
			}
			// clean up globals
			return $image;
		}

		function processImage ( &$img, $width, $height ) {
			if(!$img) return;
			$img = str_replace(JURI::base(),'',$img);
			$img = rawurldecode($img);
			$imagesurl = (file_exists(JPATH_SITE .'/'.$img)) ? JaNewsHelper::jaResize($img,$width,$height) :  '' ;
			return $imagesurl;
		}
		
		function jaResize($image,$max_width,$max_height){
			$path = JPATH_SITE;
			$sizeThumb = getimagesize(JPATH_SITE.'/'.$image);
			$width = $sizeThumb[0];
			$height = $sizeThumb[1];
			if(!$max_width && !$max_height) {
        $max_width = $width;
        $max_height = $height;
      }else{
        if(!$max_width) $max_width = 1000;
        if(!$max_height) $max_height = 1000;
      }
			$x_ratio = $max_width / $width;
			$y_ratio = $max_height / $height;
			if (($width <= $max_width) && ($height <= $max_height) ) {
				$tn_width = $width;
				$tn_height = $height;
			} else if (($x_ratio * $height) < $max_height) {
				$tn_height = ceil($x_ratio * $height);
				$tn_width = $max_width;
			} else {
				$tn_width = ceil($y_ratio * $width);
				$tn_height = $max_height;
			}
			// read image
			$ext = strtolower(substr(strrchr($image, '.'), 1)); // get the file extension
			$rzname = strtolower(substr($image, 0, strpos($image,'.')))."_{$tn_width}_{$tn_height}.{$ext}"; // get the file extension
			$resized = $path.'/images/resized/'.$rzname;
			if(file_exists($resized)){
				$smallImg = getimagesize($resized);
				if (($smallImg[0] <= $tn_width && $smallImg[1] == $tn_height) ||
					($smallImg[1] <= $tn_height && $smallImg[0] == $tn_width)) {
						return "images/resized/".$rzname;
				}
			}
			if(!file_exists($path.'/images/resized/') && !mkdir($path.'/images/resized/',0755)) return '';
			$folders = explode('/',$image);
			$tmppath = $path.'/images/resized/';
			for($i=0;$i < count($folders)-1; $i++){
				if(!file_exists($tmppath.$folders[$i]) && !mkdir($tmppath.$folders[$i],0755)) return '';
				$tmppath = $tmppath.$folders[$i].'/';
			}
			switch ($ext) {
				case 'jpg':     // jpg
					$src = imagecreatefromjpeg(JPATH_SITE.'/'.$image);
					break;
				case 'png':     // png
					$src = imagecreatefrompng(JPATH_SITE.'/'.$image);
					break;
				case 'gif':     // gif
					$src = imagecreatefromgif(JPATH_SITE.'/'.$image);
					break;
				default:
			}
			$dst = imagecreatetruecolor($tn_width,$tn_height);
			//imageantialias ($dst, true);
			if (function_exists('imageantialias')) imageantialias ($dst, true);
			imagecopyresampled ($dst, $src, 0, 0, 0, 0, $tn_width, $tn_height, $width, $height);
			imagejpeg($dst, $resized, 90); // write the thumbnail to cache as well...
			return "images/resized/".$rzname;
		}

		function unhtmlentities($string) 
		{
			$trans_tbl = array("&lt;" => "<", "&gt;" => ">", "&amp;" => "&");
			return strtr($string, $trans_tbl);
		}

		function getFile($name, $comPath, $tmplPath) {
			if (file_exists(JPATH_SITE.DS.$tmplPath.$name)) {
				return $tmplPath.$name;
			}
			return $comPath.$name;
		}
	}
	
	class SmartTrim {    
    /*
      $hiddenClasses: Class that have property display: none or invisible.
    */
    function trim($strin, $pos=0, $len=10000, $hiddenClasses = '' ) {
      $strout = trim($strin);
      
      $pattern = '/(<[^>]*>)/';
      $arr = preg_split($pattern, $strout, -1, PREG_SPLIT_DELIM_CAPTURE);
      $left = $pos;
      $length = $len;
      $strout = '';
      for($i=0;$i<count($arr);$i++) {
        $arr[$i] = trim($arr[$i]);
        if ($arr[$i] == '') continue;
        if ($i % 2 == 0) {
          if($left > 0) {
            $t = $arr[$i]; 
            $arr[$i] = substr($t, $left);
            $left -= (strlen ($t) - strlen ($arr[$i]));
          }
          
          if ($left <= 0) {
            if ($length > 0) {
              $t = $arr[$i];
              $arr[$i] = substr($t, 0, $length);
              $length -= strlen ($arr[$i]);
              if ($length <= 0) {
                $arr[$i] .= '...';
              }
              
            } else {
              $arr[$i] = '';
            }
          }
        }else{
          if (SmartTrim::isHiddenTag ($arr[$i], $hiddenClasses)) {
            if ($endTag = SmartTrim::getCloseTag($arr, $i)){
              while ($i<$endTag) $strout .= $arr[$i++]."\n";
            }
          }
        }
        $strout .= $arr[$i]."\n";
      }
      //echo $strout;  
      return SmartTrim::toString($arr, $len);
    }
    
    function isHiddenTag ($tag, $hiddenClasses='') {
      //By pass full tag like img
      if (substr($tag, -2)=='/>') return false;
      if (in_array(SmartTrim::getTag($tag), array('script','style'))) return true;
      if (preg_match('/display\s*:\s*none/', $tag)) return true;
      if ($hiddenClasses && preg_match('/class\s*=[\s"\']*('.$hiddenClasses.')[\s"\']*/', $tag)) return true;
    }
    
    function getCloseTag ($arr, $openidx) {
      $tag = trim($arr[$openidx]);
      if(!$openTag = SmartTrim::getTag($tag)) return 0;
      
      $endTag = "</$openTag>";
      $endidx = $openidx+1;
      $i=1;
      while ($endidx<count($arr)) {
        if (trim($arr[$endidx]) == $endTag) $i--;
        if (SmartTrim::getTag($arr[$endidx])==$openTag) $i++;
        if ($i == 0) return $endidx;
        $endidx++;
      }
      return 0;
    }
    
    function getTag ($tag) {
      if (preg_match ('/\A<([^\/>]*)\/>\Z/', trim($tag), $matches)) return ''; //full tag
      if (preg_match ('/\A<([^ \/>]*)([^>]*)>\Z/', trim($tag), $matches)) {
        //echo "[".strtolower($matches[1])."]";
        return strtolower($matches[1]);
      }
      //if (preg_match ('/<([^ \/>]*)([^\/>]*)>/', trim($tag), $matches)) return strtolower($matches[1]);
      return '';
    }
    
    function toString ($arr, $len) {
      $i = 0;
      $stack = new JAStack();
      
      $length = 0;
      while ($i<count($arr)) {
        $tag = trim($arr[$i++]); 
        if ($tag == '') continue;
        if (SmartTrim::isCloseTag ($tag)){
          if ($ltag = $stack->getLast()){
            if ('</'.SmartTrim::getTag($ltag).'>' == $tag) $stack->pop();
            else $stack->push($tag);
          }
        } else if (SmartTrim::isOpenTag ($tag)) {
          $stack->push ($tag);
        } else if (SmartTrim::isFullTag ($tag)) {
          //echo "[TAG: $tag, $length, $len]\n";
          if ($length < $len)
            $stack->push ($tag);
        } else {
          $length += strlen ($tag);
          $stack->push ($tag);     
        }
      }
      
      return $stack->toString();
    }

    function isOpenTag ($tag) {
      if (preg_match ('/\A<([^\/>]+)\/>\Z/', trim($tag), $matches)) return false; //full tag
      if (preg_match ('/\A<([^ \/>]+)([^>]*)>\Z/', trim($tag), $matches)) return true;
      return false;
    }
    
    function isFullTag ($tag) {
      //echo "[Check full: $tag]\n";
      if (preg_match ('/\A<([^\/>]*)\/>\Z/', trim($tag), $matches)) return true; //full tag
      return false;
    }
    
    function isCloseTag ($tag) {
      if (preg_match ('/<\/(.*)>/', $tag)) return true;
      return false;
    }    
  }
  
  class JAStack {
    var $_arr = null;
    function JAStack() {
      $this->_arr = array();
    }
    
    function push ($item) {
      $this->_arr[count($this->_arr)] = $item;
    }
    function pop () {
      if (!$c = count($this->_arr)) return null;
      $ret = $this->_arr[$c-1];
      unset ($this->_arr[$c-1]);
      return $ret;
    }
    function getLast() {
      if (!$c = count($this->_arr)) return null;
      return $this->_arr[$c-1];
    }
    function toString() {
      $output = '';
      foreach ($this->_arr as $item) {
        $output .= $item."\n";      	
      }
      return $output;
    }
  }	
}